<?php
/*
Plugin Name: regenerate_thumbnails
Description: regenerate thumbnails.
Version: 1.1
Author: jjancel 15/05/2024 18:00
Author URI: http://jjancel.free.fr/
*/
 
# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile,       # Plugin id
	'Regenerate Thumbnails', # Plugin name
	'1.1',      # Plugin version
	'jjancel',  # Plugin author
	'http://jjancel.free.fr/', # author website
	'Regenerate Thumbnails', # Plugin description
	'files', # page type of plugin
	'regenerate_thumbnails_show' # main plugin function
);

# activate filter
add_action('files-sidebar','createSideMenu',array($thisfile,'Regenerate Thumbnails'));

# functions
function regenerate_thumbnails_show() {
	if (isset($_POST['submitted'])) {
		echo '<h3>list of all images in the data/uploads folder and subfolders</h3>';
		$uploaddir = '../data/uploads';
		listFolderFiles($uploaddir);
	}
	echo '<h3>How use Regenerate Thumbnails on your files?</h3>';
	echo "<p>Regenerate Thumbnails allows you to regenerate all thumbnails for all uploaded images in your data/uploads folder and sub folder.</p> <p>This is useful in situations such as:</p> <ul> 	<li>The thumbnail size has changed and you want previous uploads to have a thumbnail of this size.</li> 	<li>You've moved to a new GetSimple theme that uses thumbnail images of a different size.</li> </ul> <p>In order to free up space on the server you can delete old, unused thumbnails from the data/thumbs folder and sub folder.</p>";
	echo '<form method="post" action="';
	echo $_SERVER["PHP_SELF"];
	echo '?id=regenerate_thumbnails"> <input type="submit" name="submitted"/> </form>';
}

# functions thumbnails
function frmtFolder($Entity) {
	echo '<li style="font-weight:bold;color:black;list-style-type:none">'.$Entity;
}

function frmtFile($dEntry, $fEntry) {
	if (preg_match('/(\.gif|\.jpg|\.jpeg|\.png|\.webp)$/i', $fEntry)) {
		$subFolder = substr($dEntry, 16).'/';
		echo '<li style="list-style-type:square;" > <a href="'.$dEntry.'/'.$fEntry.'" rel="facybox_i" style="text-decoration:none;"> <img src="'.$dEntry.'/'.$fEntry.'" width="20px" style="vertical-align:middle;"> '.$fEntry.' </a><br>';
		// generate thumbnail				
		require_once('inc/imagemanipulation.php');	
		genStdThumb($subFolder,$fEntry);
	}
}

function listFolderFiles($dir) {
	$ffs = scandir($dir);
	unset($ffs[array_search('.', $ffs, true)]);
	unset($ffs[array_search('..', $ffs, true)]);
	unset($ffs[array_search('index.html', $ffs, true)]);
	// prevent empty ordered elements
	if (count($ffs) < 1) {return;}
	echo '<div class="All Images Images iimage"><ul>';
	foreach ($ffs as $ff) {
		if (is_dir($dir . '/' . $ff)) {
			frmtFolder($dir);
		} else {
			frmtFile($dir, $ff);
		}
		if (is_dir($dir . '/' . $ff)) {
			listFolderFiles($dir . '/' . $ff);
		}
		echo '</li>';
	}
	echo '</ul></div>';
}
?>